import React from "react";

import InputComponent from "../common";
import useForm from "../common/useForm";

const SingUp = () => {
	const form = {
		firstName: {
			value: "",
			config: {
				type: "text",
				name: "firstName",
				placeholder: "Enter your First Name"
			},
			valid: false,
			touch: false,
			validation: {
				required: true
			}
		},
		lastName: {
			value: "",
			config: {
				type: "text",
				name: "lastName",
				placeholder: "Enter your Last Name"
			},
			valid: false,
			touch: false,
			validation: {
				required: true
			}
		},
		email: {
			value: "",
			config: {
				type: "email",
				name: "email",
				placeholder: "Enter your email"
			},
			valid: false,
			touch: false,
			validation: {
				required: true
			}
		},
		password: {
			value: "",
			config: {
				type: "password",
				name: "password",
				placeholder: "Enter your password"
			},
			valid: false,
			touch: false,
			validation: {
				required: true,
				minLength: 5
			}
		},
		confirmPassword: {
			value: "",
			config: {
				type: "password",
				name: "confirmPassword",
				placeholder: "Confirm your password"
			},
			valid: false,
			touch: false,
			validation: {
				required: true,
				minLength: 5
			}
		},
		isValid: false
	};

	const [newObject, { setNew }] = useForm(form);

	const checkObject = obj => Object.prototype.toString.call(obj) === "[object Object]";

	const change = e => {
		const { value, name } = e.target;

		setNew({ value, name });
	};

	const submit = e => {
		e.preventDefault();

		console.log("newForm", newObject);
	};

	return (
		<form onSubmit={submit}>
			{Object.keys(newObject).map(
				el =>
					checkObject(newObject[el]) && (
						<InputComponent
							key={el}
							touch={newObject[el].touch}
							valid={!newObject[el].valid}
							config={{ ...newObject[el].config, value: newObject[el].value, onChange: change }}
						/>
					)
			)}

			<button disabled={!newObject.isValid}>Submit</button>
		</form>
	);
};

export default SingUp;
